## munin 2.999.16

=== Makefile ===

# This Makefile provides convenience targets for common build/test/install cases, as well as rules
# for the release manager.

# In the interest of keeping this Makefile simple, it does not attempt to provide the flexibility
# provided by using Build.PL directly. (See perldoc Module::Build).

# Defaults/paths. Allows $(CONFIG) to be overridden by
# make command line
DEFAULTS = Makefile.config
CONFIG = Makefile.config

PYTHON_LINT_CALL ?= python3 -m flake8

include $(DEFAULTS)
ifneq ($(DEFAULTS),$(CONFIG))
    include $(CONFIG)
endif

# the perl script is used for most perl related activities
BUILD_SCRIPT = ./Build


.PHONY: default
default: build

.PHONY: help
help:
	@echo "Build targets:"
	@echo "    build"
	@echo "    clean"
	@echo "    doc"
	@echo "    install"
	@echo "    tar"
	@echo
	@echo "Test targets:"
	@echo "    lint"
	@echo "    test"
	@echo "    testcover"
	@echo "    testpod"
	@echo "    testpodcoverage"
	@echo

.PHONY: build
build: $(BUILD_SCRIPT)
	$(BUILD_SCRIPT)

.PHONY: doc
doc:
	$(MAKE) -C doc html

.PHONY: install
install: $(BUILD_SCRIPT)
	"$(BUILD_SCRIPT)" install --destdir="$(DESTDIR)" --verbose
	@# various directory placeholders (e.g. "@@SPOOLDIR@@") need to be replaced
	grep -rl --null "@@" "$(or $(DESTDIR),.)" | xargs -0 sed -i \
		-e "$$(perl -I lib -M"Munin::Common::Defaults" \
			-e "Munin::Common::Defaults->print_as_sed_substitutions();")"

.PHONY: apply-formatting
apply-formatting:
	# Format munin perl files with the recommend perltidy settings
	# This is recommend, but NOT mandatory
	@# select all scipts except munin-check
	perltidy script/munin-async script/munin-asyncd script/munin-cron.PL script/munin-doc script/munin-httpd script/munin-limits script/munin-node script/munin-node-configure script/munin-run script/munin-update
	@# format munin libraries
	find lib/ -type f -exec perltidy {} \;

.PHONY: lint lint-munin lint-plugins lint-spelling lint-whitespace

lint: lint-munin lint-plugins lint-spelling lint-whitespace

lint-munin: build
	# Scanning munin code
	perlcritic --profile .perlcriticrc lib/ script/
	shellcheck --shell dash getversion script/munin-get script/munin-cron

lint-plugins:
	@# SC1008: ignore our weird shebang (substituted later)
	@# SC1090: ignore sourcing of files with variable in path
	@# SC2009: do not complain about "ps ... | grep" calls (may be platform specific)
	@# SC2126: tolerate "grep | wc -l" (simple and widespread) instead of "grep -c"
	# TODO: fix the remaining shellcheck issues for the missing platforms:
	#       aix, darwin, netbsd, sunos
	#       (these require tests with their specific shell implementations)
	find plugins/node.d/ \
			plugins/node.d.cygwin/ \
			plugins/node.d.debug/ \
			plugins/node.d.linux/ -type f -print0 \
		| xargs -0 grep -l --null '^#!.*/bin/sh' \
			| xargs -0 shellcheck --exclude=SC1008,SC1090,SC2009,SC2126 --shell dash
	find plugins/ -type f -print0 \
		| xargs -0 grep -l --null "^#!.*/bin/bash" \
			| xargs -0 shellcheck --exclude=SC1008,SC1090,SC2009,SC2126 --shell bash
	find plugins/ -type f -print0 \
		| xargs -0 grep -l --null "^#!.*python" \
			| xargs -0 $(PYTHON_LINT_CALL)
	# TODO: perl plugins currently fail with perlcritic
	# verify that no multigraph plugin lacks a check for the node's capability
	# Three capability checks are detected:
	#     * perl: need__multigraph();
	#     * shell: is_multigraph
	#     * perl with "Munin::Plugin::Framework": we assume the framework takes care for it
	#     * manual: evaluate environment variable MUNIN_CAP_MULTIGRAPH
	# Some files are excluded from the test:
	#     * plugins/node.d.debug/*: these plugins are used only for testing
	#     * AbstractMultiGraphsProvider.java: this is not a plugin
	plugins_without_multigraph_check=$$(grep -rlwZ "multigraph" plugins/ \
		| xargs -r -0 grep -LwE '((need|is)_multigraph|Munin::Plugin::Framework|MUNIN_CAP_MULTIGRAPH)' \
		| grep -vE 'plugins/(node\.d\.debug/|.*/AbstractMultiGraphsProvider\.java)'); \
		if [ -n "$$plugins_without_multigraph_check" ]; then \
			echo '[ERROR] Some plugins lack a "multigraph" check (e.g. "needs_multigraph();" or "is_multigraph"):'; \
			echo "$$plugins_without_multigraph_check" | sed 's/^/\t/'; false; fi >&2

lint-spelling: CODESPELL_ARGS += --exclude-file=.codespell.exclude
# codespell introduced "--ignore-words" in v1.14 (Debian Buster)
lint-spelling: CODESPELL_ARGS += $(shell if codespell --help | grep -q " --ignore-words "; then echo "--ignore-words=.codespell.ignore-words"; fi)
lint-spelling:
	# codespell misdetections may be ignored by adding the full line of text to the file .codespell.exclude
	find . -type f -print0 \
		| grep --null-data -vE '^\./(\.git|\.pc|doc/_build|blib|.*/blib|build|sandbox|web/static/js|contrib/plugin-gallery/www/static/js)/' \
		| grep --null-data -vE '\.(svg|png|gif|ico|css|woff|woff2|ttf|eot|pem)$$' \
		| xargs -0 -r codespell $(CODESPELL_ARGS)

lint-whitespace: FILES_WITH_TRAILING_WHITESPACE = $(shell grep -r -l --binary-files=without-match \
				--exclude-dir=.git --exclude-dir=sandbox '\s$$' . \
			| grep -vE '/(blib|build|_build|web/static)/' \
			| grep -vE '/logo\.eps$$')

lint-whitespace:
	@if [ -n "$(FILES_WITH_TRAILING_WHITESPACE)" ]; then \
		echo 'Files containing trailing whitespace or non-native line endings:'; \
		printf '\t%s\n' $(FILES_WITH_TRAILING_WHITESPACE); \
		false; fi 2>&1


.PHONY: clean
clean: $(BUILD_SCRIPT)
	"$(BUILD_SCRIPT)" realclean
	rm -rf _stage
	rm -f MANIFEST META.json META.yml
	$(MAKE) -C doc clean


##############################
# perl module

$(BUILD_SCRIPT): Build.PL
	$(PERL) Build.PL --destdir="$(DESTDIR)" --installdirs="$(INSTALLDIRS)" --verbose


######################################################################
# testing

TEST_FILES_ARG = $(addprefix --test_files , $(TEST_FILES))

.PHONY: test
test: $(BUILD_SCRIPT)
	"$(BUILD_SCRIPT)" test $(TEST_FILES_ARG)

.PHONY: testcover
testcover: $(BUILD_SCRIPT)
	"$(BUILD_SCRIPT)" testcover $(TEST_FILES_ARG)

.PHONY: testpod
testpod: $(BUILD_SCRIPT)
	"$(BUILD_SCRIPT)" testpod $(TEST_FILES_ARG)

.PHONY: testpodcoverage
testpodcoverage: $(BUILD_SCRIPT)
	"$(BUILD_SCRIPT)" testpodcoverage $(TEST_FILES_ARG)


######################################################################
# Rules for the release manager

RELEASE := $(shell $(CURDIR)/getversion)

.PHONY: tar
tar: munin-$(RELEASE).tar.gz.sha256sum

.PHONY: tar-signed
tar-signed: munin-$(RELEASE).tar.gz.asc

munin-$(RELEASE).tar.gz:
	@# prevent the RELEASE file from misleading the "getversion" script
	rm -f RELEASE
	tempdir=$$(mktemp -d) \
		&& mkdir -p "$$tempdir/munin-$(RELEASE)/" \
		&& echo $(RELEASE) > "$$tempdir/munin-$(RELEASE)/RELEASE" \
		&& git archive --prefix=munin-$(RELEASE)/ --format=tar --output "$$tempdir/export.tar" HEAD \
		&& tar --append --file "$$tempdir/export.tar" --owner=root --group=root -C "$$tempdir" "munin-$(RELEASE)/RELEASE" \
		&& gzip -9 <"$$tempdir/export.tar" >"munin-$(RELEASE).tar.gz" \
		&& rm -rf "$$tempdir"

munin-$(RELEASE).tar.gz.sha256sum: munin-$(RELEASE).tar.gz
	sha256sum "$<" >"$@"

munin-$(RELEASE).tar.gz.asc: munin-$(RELEASE).tar.gz
	gpg --armor --detach-sign --sign "$<"

.PHONY: tar-upload
tar-upload: tar tar-signed
	@if [ -z "$(UPLOAD_DIR)" ]; then echo "You need to set UPLOAD_DIR (e.g. '/srv/www/downloads.munin-monitoring.org/munin/stable')" >&2; false; fi
	@if [ -z "$(UPLOAD_HOST)" ]; then echo "You need to set UPLOAD_HOST" >&2; false; fi
	{ \
		echo "mkdir $(UPLOAD_DIR)/$(VERSION)"; \
		echo "put munin-$(VERSION).tar.gz* $(UPLOAD_DIR)/$(VERSION)/"; \
	} | sftp -b - "$(UPLOAD_HOST)"

.PHONY: docker
docker-base:
	docker build -t munin:base -f Dockerfile.base .
docker: docker-base
	./getversion > RELEASE.docker
	docker build -t munin:latest .
	docker rm -f munin || true
	# Add the following to enable strace in the container
	# --security-opt seccomp:unconfined
	docker run --name munin --shm-size=256M -p 4948:4948 -itd munin:latest dev_scripts/noop

docker-connect:
	docker exec -it munin bash

docker-dev: docker-base
	docker build -t munin:dev -f Dockerfile.dev .
	docker run --rm --name munin-dev -v $(shell pwd):/munin -p 8000:8000 -p 14947:4947 -p 14948:4948 -it munin:dev

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

# Using 2 commands, since $(BUILDDIR) can be a symlink.
# Usually to a subdir in $HOME/public_html/
clean:
	-rm -Rf -- $(BUILDDIR)/*
	-[ ! -d $(BUILDDIR) ] || rmdir -p -- $(BUILDDIR)

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Munin.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Munin.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Munin"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Munin"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== t/tls/Makefile ===
SUBJECT_CA = /C=MU/ST=Province of Munin/L=Munin Town/O=Munin Inc./OU=CA/CN=127.0.0.1/emailAddress=munin@example.org/
SUBJECT_MASTER = /C=MU/ST=Province of Munin/L=Munin Town/O=Munin Inc./OU=Master/CN=127.0.0.1/emailAddress=munin@example.org/
SUBJECT_NODE = /C=MU/ST=Province of Munin/L=Munin Town/O=Munin Inc./OU=Node/CN=127.0.0.1/emailAddress=munin@example.org/


.PHONY: all clean

all:
	mkdir CA
	mkdir CA/newcerts CA/private
	touch CA/index.txt
	echo '01' > CA/serial
	openssl req -new -nodes -x509 -extensions v3_ca -subj "$(SUBJECT_CA)" -keyout CA/private/ca_key.pem -out CA/ca_cert.pem -days 3650 -config ./openssl.cnf
	openssl req -new -nodes -subj "$(SUBJECT_NODE)" -keyout node_key.pem -out node_req.pem -config ./openssl.cnf
	openssl req -new -nodes -subj "$(SUBJECT_MASTER)" -keyout master_key.pem -out master_req.pem -config ./openssl.cnf
	yes | openssl ca -out node_cert.pem -in node_req.pem -config ./openssl.cnf -days 3650
	yes | openssl ca -out master_cert.pem -in master_req.pem -config ./openssl.cnf -days 3650

clean:
	rm -r CA
	rm *.pem

=== debian/changelog ===
munin (2.999.16-1) experimental; urgency=medium

  [ Holger Levsen ]
  * New upstream release.
  * Bump standards version to 4.6.0, no changes needed.

  [ lintian-brush ]
  * Use secure URI in Homepage field.
  * Remove 29 obsolete maintscript entries in 25 files.

 -- Holger Levsen <holger@debian.org>  Thu, 10 Feb 2022 01:24:56 +0100

munin (2.999.15-3) experimental; urgency=medium

  [ Lars Kruse ]
  * Fix debugging output of local network configuration during build.

 -- Holger Levsen <holger@debian.org>  Thu, 01 Oct 2020 00:18:27 +0200

munin (2.999.15-2) experimental; urgency=medium

  [ Lars Kruse ]
  * Show local network configuration during build (for debugging purposes).
  * Add build dependency libhttp-server-simple-cgi-prefork-perl.
  * Move obsolete fields Contact and Name from debian/upstream/metadata to
    their new location in debian/copyright.

 -- Holger Levsen <holger@debian.org>  Tue, 29 Sep 2020 17:01:07 +0200

munin (2.999.15-1) experimental; urgency=medium

  * New upstream release.
    - update debian/patches/disable-munin-limits.patch.
    - munin-node: add /usr/bin/munin-get, which is a simple tool for managing
      plugins from remote repositories. Not yet ship its manpage.
    - add build-dependency on libdevel-confess-perl and drop the python one.
      Closes: #968023
    - munin-node and munin-run manpages have moved from section 1 to 8, adjust
      d/munin-node.manpages and d/munin-node.service accordingly.
  * Bump debhelper-compat to 13. Adjust d/rules override_dh_installdocs to use
    use --remaining-packages.
  * Bump standards version to 4.5.0, no changes needed.

 -- Holger Levsen <holger@debian.org>  Mon, 28 Sep 2020 14:23:53 +0200

munin (2.999.14-1) experimental; urgency=medium

  * New upstream release.
  * Re-export upstream signing key without extra signatures.
    (thanks, lintian-brush)
  * Add lintian override for uses-dpkg-database-directly of a plugin
    in munin-plugins-core.  (thanks, lintian)
  * Change Vcs-Git to canonical URL (adding trailing ".git").
    (thanks, lintian)
  * Replace "dpkg-parsechangelog" call in d/rules with SOURCE_DATE_EPOCH.
    (thanks, lintian)

  [ Holger Levsen ]
  * Bump debhelper-compat to 12.

 -- Holger Levsen <holger@debian.org>  Thu, 01 Aug 2019 16:48:33 -0300

munin (2.999.13-1) experimental; urgency=medium

  * New upstream release.
  * Bump standards version to 4.4.0, no changes needed.

 -- Holger Levsen <holger@debian.org>  Fri, 12 Jul 2019 19:38:08 +0200

munin (2.999.12-1) experimental; urgency=medium

  [ Holger Levsen ]
  * New upstream release.

  [ Lars Kruse ]
  * Add 'Webservice' field to upstream metadata.

 -- Holger Levsen <holger@debian.org>  Sat, 15 Jun 2019 13:24:55 +0200

munin (2.999.11-1) experimental; urgency=medium

  * New upstream version, drop debian/patches/manpage-master-limitsold and
    debian/patches/Makefile.javaplugin-INSTALL-variable.patch.
  * Add netbase to munin's and munin-node's depends.
  * Bump Standards-Version to 4.3.0, no changes needed.

 -- Holger Levsen <holger@debian.org>  Thu, 24 Jan 2019 13:37:23 +0100

munin (2.999.10-1) experimental; urgency=medium

  [ Lars Kruse ]
  * New upstream beta release (2.999.10), Closes: #860899

 -- Holger Levsen <holger@debian.org>  Wed, 12 Dec 2018 09:39:23 +0100

munin (2.999.9-3) experimental; urgency=medium

  [ Lars Kruse ]
  * Convert old doc directory for munin-plugins-java to symlink.
    Closes: #915020 Thanks to Andreas Beckmann for filing these bugs.

 -- Holger Levsen <holger@debian.org>  Fri, 30 Nov 2018 12:56:45 +0100

munin (2.999.9-2) experimental; urgency=medium

  [ Lars Kruse ]
  * Integrate tests from unstable packaging.

  [ Holger Levsen ]
  * Use the new debhelper-compat(=11) notation and drop d/compat.

 -- Holger Levsen <holger@debian.org>  Thu, 15 Nov 2018 11:54:10 +0100

munin (2.999.9-1) experimental; urgency=medium

  [ Lars Kruse ]
  * New upstream beta release (2.999.9)
  * munin and munin-node: use separate maintscript files
  * convert old doc directories (before "link-doc") to symlinks
    (Closes: #881713)
  * Add missing package "munin-plugins-java".
    (it was provided by the munin 2.0 package before)
  * d/rules: use $(MAKE) instead of "make"
  * autopkgtest: update embedded "sharness" from 0.3 to 1.0
    (Thanks to Christian Göttsche:
     https://github.com/munin-monitoring/munin/issues/844)
  * autopkgtest: adjust paths and calling parameters
  * d/tests: use "set -eu" in test scripts
    (Thanks, Christian Göttsche)
  * Replace embedded copy of "sharness" with test dependency
  * Bump Standards-Version to 4.2.1, no changes needed.
  * Specify "Rules-Requires-Root" as "no"
  * Fix trivial spelling mistakes below debian/ (thanks "codespell")
  * Fix minor whitespace inconsistencies in NEWS and README files
  * Skip munin init script in systemd environment (the created
    directories are generated via systemd-tmpfiles)
  * Plugins mysql_*: switch "mysqluser" from "debian-sys-maint" to "root"
    (Closes: #862238, #864845)
  * Patch for Makefile: set INSTALL if necessary
  * Fix issues related to "Rules-Requires-Root"
  * Patch for upstream problem in LimitsOld.pm
  * Change copyright file to DEP-5 format (thanks, lintian)
  * Patch configuration handling for "munin-limits"
  * Revive /etc/munin/plugin-conf.d/munin-node
    (it is missing since commit 11f5659344 - uploaded as 2.999.3-1)
  * Add Depends for libcache-cache-perl to munin-plugins-mysql
    (Thanks, Christian Göttsche)
  * Add Recommends for libnet-ldap-perl to munin-plugins-ldap
    (Thanks, Christian Göttsche)
  * Add multiple Suggests for munin-plugins-extra
  * Set "PrivateDevices=false" for "munin-node" service in order to
    allow plugins like "smart_" to access devices
    (Thanks, Christian Göttsche)
  * Add debian/upstream/metadata
  * Use dpkg/pkg-info.mk for DEB_VERSION_UPSTREAM instead of
    dpkg-parsechangelog (Thanks, lintian)
  * Remove unused lintian override for missing source of javascript file


=== debian/control ===
Source: munin
Section: net
Priority: optional
Maintainer: Munin Debian Maintainers <team+munin@tracker.debian.org>
Uploaders: Holger Levsen <holger@debian.org>,
 Stig Sandbeck Mathisen <ssm@debian.org>,
Build-Depends-Indep:
 default-jdk-headless,
 devscripts,
 libdbd-pg-perl,
 libdbd-sqlite3-perl,
 libdevel-confess-perl,
 libdevel-nytprof-perl,
 libfile-copy-recursive-perl,
 libfile-readbackwards-perl,
 libfile-slurp-perl,
 libhtml-template-perl,
 libhtml-template-pro-perl,
 libhttp-server-simple-cgi-prefork-perl,
 libio-socket-inet6-perl,
 libio-stringy-perl,
 liblist-moreutils-perl,
 liblog-dispatch-perl,
 libnet-dns-perl,
 libnet-ip-perl,
 libnet-server-perl,
 libnet-snmp-perl,
 libnet-ssleay-perl,
 libparallel-forkmanager-perl,
 libparams-validate-perl,
 librrds-perl,
 libtest-class-perl,
 libtest-deep-perl,
 libtest-differences-perl,
 libtest-exception-perl,
 libtest-longstring-perl,
 libtest-mockmodule-perl,
 libtest-mockobject-perl,
 libtest-perl-critic-perl,
 liburi-perl,
 libwww-perl,
 libxml-dumper-perl,
 libxml-libxml-perl,
 libxml-parser-perl,
 perl,
 python3-sphinx,
 ruby,
Build-Depends: debhelper-compat (=13), libmodule-build-perl
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://munin-monitoring.org
Vcs-Git: https://salsa.debian.org/debian/munin.git -b debian-experimental
Vcs-Browser: https://salsa.debian.org/debian/munin

Package: munin-node
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 adduser,
 libnet-server-perl,
 libmunin-node-perl,
 munin-common (>= ${binary:Version}),
 netbase,
Recommends:
 munin-plugins-core,
Suggests:
 munin-plugins-extra,
 munin-plugins-http,
 munin-plugins-java,
 munin-plugins-pgsql,
 munin-plugins-snmp,
 munin,
Description: network-wide graphing framework (node)
 This package contains the daemon for the nodes being monitored. You
 should install it on all the nodes in your network. It will know how
 to extract all sorts of data from the node it runs on, and will wait
 for the gatherer to request this data for further processing.
 .
 Munin is a highly flexible and powerful solution used to create
 graphs of virtually everything imaginable throughout your network,
 while still maintaining a rattling ease of installation and
 configuration.
 .
 Munin is written in Perl, and relies heavily on Tobi Oetiker's
 excellent RRDtool. To see a real example of Munin in action, you can
 follow a link from <http://munin-monitoring.org/> to a live
 installation.

Package: munin-plugins-core
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 libmunin-plugin-perl,
 munin-common,
 procps,
 gawk,
Suggests:
 acpi | lm-sensors,
 ethtool,
 hdparm,
 conntrack,
 smartmontools,
 net-tools,
 time,
 libfile-readbackwards-perl,
 libnet-netmask-perl,
 libxml-simple-perl,
 logtail,
 libtext-csv-xs-perl,
 libnet-telnet-perl,
 libxml-parser-perl,
 libcache-cache-perl,
 libnet-dns-perl,
Replaces: munin-plugins-extra (<< 2.999.1-1~)
Breaks: munin-plugins-extra (<< 2.999.1-1~)
Description: network-wide graphing framework (plugins for node)
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains the official plugins for the Munin node,
 capable of extracting common values such as cpu usage, network usage,
 load average, and so on.
 .
 This package suggests, but does not depend on, modules and utilities
 needed by the various munin plugins.

Package: munin-plugins-extra
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 munin-common,
Recommends:
 python3,
 ruby,
Suggests:
 libcache-memcached-perl,
 libhttp-date-perl,
 libnet-ip-perl,
 libnet-netmask-perl,
 libnet-snmp-perl,
 libtext-csv-xs-perl,
 libwww-perl,
 libxml-libxml-perl,
Replaces: munin-plugins-core (<< 2.999.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~)
Description: community contributed plugins for munin node
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains community contributed plugins for the Munin
 node.

Package: munin-plugins-java
Architecture: all
Depends: ${misc:Depends},
 munin-common,
 default-jre-headless,
Replaces: munin-plugins-core (<< 2.999.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~)
Description: Java-related plugins for munin node
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring Java-related
 services.

Package: munin-plugins-http
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 libmunin-plugin-http-perl,
 libwww-perl,
 munin-common,
Replaces: munin-plugins-core (<< 2.999.1-1~),
 munin-plugins-extra (<<2.999.6-5)
Breaks: munin-plugins-core (<< 2.999.1-1~),
 munin-plugins-extra (<<2.999.6-5)
Description: munin plugins for monitoring web servers
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring web servers using
 http.

Package: munin-plugins-mysql
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 libdbd-mysql-perl,
 libcache-cache-perl,
 munin-common,
 default-mysql-client,
Replaces: munin-plugins-core (<< 2.999.1-1~),
 munin-plugins-extra (<<2.999.6-5)
Breaks: munin-plugins-core (<< 2.999.1-1~),
 munin-plugins-extra (<<2.999.6-5)
Description: munin plugins for monitoring MySQL
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring MySQL servers.

Package: munin-plugins-pgsql
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 libdbd-pg-perl,
 libmunin-plugin-pgsql-perl,
Replaces: munin-plugins-core (<< 2.999.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~)
Description: munin plugins for monitoring PostgreSQL
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring PostgreSQL
 servers.

Package: munin-plugins-snmp
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 libmunin-plugin-snmp-perl,
 munin-common,
Replaces: munin-plugins-core (<< 2.999.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~)
Description: munin plugins for monitoring remote devices with SNMP
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring remote devices
 with SNMP.

Package: munin-plugins-ldap
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
Recommends: libnet-ldap-perl
Replaces: munin-plugins-core (<< 2.999.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~)
Description: munin plugins for monitoring LDAP servers
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring LDAP servers.

Package: munin-plugins-irc
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 libnet-irc-perl,
Replaces: munin-plugins-core (<< 2.999.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~)
Description: munin plugins for monitoring IRC servers
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugin for monitoring IRC servers.

Package: munin-plugins-dns
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends}, bind9utils
Replaces: munin-plugins-core (<< 2.999.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~)
Description: munin plugins for monitoring DNS servers
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring DNS servers.

Package: munin-plugins-mail
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 munin-common,
Replaces: munin-plugins-core (<< 2.999.1-1~), munin-plugins-extra (<< 2.99.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~), munin-plugins-extra (<< 2.99.1-1~)
Description: munin plugins for monitoring mail servers
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring mail servers.

Package: munin-plugins-time
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
Replaces: munin-plugins-core (<< 2.999.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~)
Description: munin plugins for monitoring NTP servers and synchronization
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring time servers and
 synchronization. Plugins can monitor local and remote NTP servers.

Package: munin-plugins-network
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 munin-common,
Replaces: munin-plugins-core (<< 2.999.1-1~)
Breaks: munin-plugins-core (<< 2.999.1-1~)
Description: munin plugins for monitoring network traffic
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring network traffic
 and usage.  Common tools used is netfilter/iptables, snort.

Package: munin-plugins-jenkins
Architecture: all
Depends: ${misc:Depends},
 munin-common,
Description: munin plugins for monitoring the Jenkins CI server
 Munin plugins collect details of a host or its environment.
 The munin-node daemon provides access to the plugin to local or remote
 munin master instances.
 .
 This package contains munin plugins for monitoring a local Jenkins CI
 server.

Package: libmunin-perl
Section: perl
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends},
 liblog-dispatch-perl,
 libparams-validate-perl,
Recommends:
 libnet-ssleay-perl,
Replaces: munin-common (<< 2.999.1-1~),
 munin-doc (<<2.999.6-5)
Breaks: munin-common (<< 2.999.1-1~),
 munin-doc (<<2.999.6-5)
Description: common perl modules for munin
 Munin is a highly flexible and powerful solution used to create
 graphs of virtually everything imaginable throughout your network,
 while still maintaining a rattling ease of installation and
 configuration.
 .
 The Munin and Munin::Common perl modules, used by munin master and
 node.

Package: libmunin-master-perl
Section: perl
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends}, libmunin-perl
Replaces: munin (<< 2.999.1-1~),
 munin-doc (<<2.999.6-5)
Breaks: munin (<< 2.999.1-1~),
 munin-doc (<<2.999.6-5)
Description: perl modules for munin master
 Munin is a highly flexible and powerful solution used to create
 graphs of virtually everything imaginable throughout your network,
 while still maintaining a rattling ease of installation and
 configuration.
 .
 The Munin::Master perl module, used by munin master.

Package: libmunin-node-perl
Section: perl
Architecture: all
Depends: ${perl:Depends}, ${misc:Depends}, libmunin-perl
Replaces: munin-node (<< 2.999.1-1~),
 munin-doc (<<2.999.6-5)
Breaks: munin-node (<< 2.999.1-1~),
 munin-doc (<<2.999.6-5)
Description: perl module Munin::Node
 Munin is a highly flexible and powerful solution used to create
 graphs of virtually everything imaginable throughout your network,

=== debian/rules ===
#! /usr/bin/make -f

# for DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

# export DH_VERBOSE=1

MAKEOPTS = INSTALLDIRS=vendor
BUILD_DATE = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "@$(SOURCE_DATE_EPOCH)")

%:
	dh $@

override_dh_auto_build:
	# ./getversion reads RELEASE if it exists
	echo "$(DEB_VERSION_UPSTREAM)" >RELEASE
	dh_auto_build -- $(MAKEOPTS)
	# show local network configuration (debugging a build failure on the buildd hosts)
	ip addr || ifconfig || true
	cat /etc/hosts || true
	# build java plugin files
	$(MAKE) -f Makefile.config -f Makefile.javaplugin build-plugins-java
	$(MAKE) -C doc html man SPHINXOPTS="-D today=\"$(BUILD_DATE)\""

override_dh_auto_install:
	dh_auto_install
	rm -rfv debian/tmp/usr/share/man/man1
	# configuration files
	mv debian/tmp/etc/munin/munin-node.conf.sample debian/tmp/etc/munin/munin-node.conf
	sed -i -e '/^log_file/clog_file Sys::Syslog' debian/tmp/etc/munin/munin-node.conf
	sed -i -e '/^pid_file/cpid_file /run/munin-node.pid' debian/tmp/etc/munin/munin-node.conf
	mv debian/tmp/etc/munin/munin.conf.sample debian/tmp/etc/munin/munin.conf
	# install debian provided plugin configuration
	install -D -m0644 debian/plugins.conf \
		$(CURDIR)/debian/munin-node/etc/munin/plugin-conf.d/munin-node
	# replace embedded copies of "fonts-materialdesignicons-webfont" with symlinks
	$(RM) debian/tmp/etc/munin/static/css/materialdesignicons.css
	ln -s ../../../../usr/share/fonts-materialdesignicons-webfont/css/materialdesignicons.css \
		debian/tmp/etc/munin/static/css/materialdesignicons.css
	$(RM) -r debian/tmp/etc/munin/static/fonts
	ln -s ../../../../usr/share/fonts-materialdesignicons-webfont/fonts \
		debian/tmp/etc/munin/static/fonts
	# replace embedded copy of "libjs-jquery" with symlink
	$(RM) debian/tmp/etc/munin/static/js/jquery-1.8.3.js
	ln -s ../../../../usr/share/javascript/jquery/jquery.js \
		debian/tmp/etc/munin/static/js/jquery.js
	sed -i 's#/js/jquery-1\.8\.3\.js#/js/jquery.js#' \
		debian/tmp/etc/munin/templates/partial/head.tmpl
	# java plugins
	$(MAKE) -f Makefile.javaplugin install-plugins-java \
		LIBDIR=debian/munin-plugins-java/usr/share/munin \
		JAVALIBDIR=debian/munin-plugins-java/usr/share/munin

override_dh_strip_nondeterminism:
	# Sadly "Rules-Requires-Root: no" combined with "ExtUtils::MakeMaker" leads to directories
	# (and files) with read-only permissions for the owner.
	# See https://alioth-lists-archive.debian.net/pipermail/debhelper-devel/2017-October/007241.html
	# We need to add owner's write permissions for changes by "dh_strip_nondeterminism".
	find debian/munin/etc/munin/static/img/ -type f -name "*.png" -perm 0444 -print0 | xargs -0 chmod u+w
	dh_strip_nondeterminism

override_dh_installinit:
	dh_installinit --package=munin-async
	dh_installinit --package=munin-node
	dh_installinit --name=munin-httpd
	dh_installinit --name=munin-rrdcached
	dh_installinit --name=munin-tmpfiles

override_dh_installsystemd:
	dh_installsystemd --package=munin
	dh_installsystemd --package=munin-async
	dh_installsystemd --package=munin-node
	dh_installsystemd --name=munin-httpd
	dh_installsystemd --name=munin-rrdcached

override_dh_installdocs:
	dh_installdocs --link-doc=munin-common --doc-main-package=munin-common -p munin-doc
	dh_installdocs --link-doc=munin-common --remaining-packages
	@ # Use the packaged javascript libraries
	rm debian/munin-doc/usr/share/doc/munin-common/html/_static/jquery.js; \
	ln -s /usr/share/javascript/jquery/jquery.js \
		debian/munin-doc/usr/share/doc/munin-common/html/_static/jquery.js; \
	rm debian/munin-doc/usr/share/doc/munin-common/html/_static/underscore.js; \
	ln -s /usr/share/javascript/underscore/underscore.js \
		debian/munin-doc/usr/share/doc/munin-common/html/_static/underscore.js; \

override_dh_missing:
	dh_missing --fail-missing

=== debian/tests/control ===
# Tests for master components:
#   * collect graphs
#   * generate html and png files
#
# Dependencies:
#   * curl: HTTP requests for munin-httpd
#   * daemontools: for "setuidgid"
#   * file: determine mime type of HTTP responses
#   * munin-node: provide data to be retrieved by the munin master
#   * munin-plugins-core: required for requesting plugin graphs via munin-httpd
#   * netcat-openbsd: test local tcp connection
#   * sharness: test framework


Tests: master-systemd
Depends: munin, munin-node, munin-plugins-core, daemontools, curl, file, netcat-openbsd, sharness
Restrictions: needs-root, breaks-testbed, isolation-container

Tests: master-sysvinit
Depends: munin, munin-node, munin-plugins-core, daemontools, curl, file, netcat-openbsd, sharness
Restrictions: needs-root, breaks-testbed, isolation-machine, needs-reboot


# Tests for munin-node:
#   * run the node
#   * access plugins
#
# Dependencies:
#   * munin-plugins-core: required for verifying plugin list and checking munin-doc
#   * sharness: test framework

Tests: node-systemd
Depends: munin-node, munin-plugins-core, netcat-openbsd, sharness
Restrictions: needs-root, breaks-testbed, isolation-container

Tests: node-sysvinit
Depends: munin-node, munin-plugins-core, netcat-openbsd, sharness
Restrictions: needs-root, breaks-testbed, isolation-machine, needs-reboot


# verify that all binary packages can be installed at the same time (without conflicts)
Test-Command: true
Depends: @
Restrictions: breaks-testbed

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s{$}{.asc} \
http://downloads.munin-monitoring.org/munin/dev/([\d\.]+)/munin-([\d\.]+).tar.gz
